| CMSIS-CORE Version 3.01 CMSIS-CORE support for Cortex-M processor-based devices

- CMSIS
- CORE
- DSP
- RTOS API
- SVD

- Main Page
- Usage and Description
- Reference

Variables | Functions
System and Clock Configuration

## Variables
uint32_t | SystemCoreClock
| Variable to hold the system core clock value.
## Functions
void | SystemInit (void)
| Function to Initialize the system.
void | SystemCoreClockUpdate (void)
| Function to update the variable SystemCoreClock.

## Description

ARM provides a template file system_device.c that must be adapted by the silicon vendor to match their actual device. As a minimum requirement, this file must provide:

- A device-specific system configuration function, SystemInit().
- A global variable that contains the system frequency, SystemCoreClock.

The file configures the device and, typically, initializes the oscillator (PLL) that is part of the microcontroller device. This file might export other functions or variables that provide a more flexible configuration of the microcontroller system.

## Code Example

The code below shows the usage of the variable SystemCoreClock and the functions SystemInit() and SystemCoreClockUpdate() with an LPC1700.

    #include "LPC17xx.h"

    uint32_t coreClock_1 = 0;                       /* Variables to store core clock values */
    uint32_t coreClock_2 = 0;

    int main (void)  {

      coreClock_1 = SystemCoreClock;                /* Store value of predefined SystemCoreClock */

      SystemCoreClockUpdate();                      /* Update SystemCoreClock according to register settings */

      coreClock_2 = SystemCoreClock;                /* Store value of calculated SystemCoreClock */

      if (coreClock_2 != coreClock_1)  {            /* Without changing the clock setting both core clock values should be the same */
        // Error Handling
      }

      while(1);
    }

## Variable Documentation

uint32_t SystemCoreClock

Holds the system core clock, which is the system clock frequency supplied to the SysTick timer and the processor core clock. This variable can be used by debuggers to query the frequency of the debug timer or to configure the trace clock speed.

Attention:
  Compilers must be configured to avoid removing this variable in case the application program is not using it. Debugging systems require the variable to be physically present in memory so that it can be examined to configure the debugger.

## Function Documentation

void SystemCoreClockUpdate | ( | void |  | ) |

Updates the variable SystemCoreClock and must be called whenever the core clock is changed during program execution. The function evaluates the clock register settings and calculates the current core clock.

void SystemInit | ( | void |  | ) |

Initializes the microcontroller system. Typically, this function configures the oscillator (PLL) that is part of the microcontroller device. For systems with a variable clock speed, it updates the variable SystemCoreClock. SystemInit is called from the file startup_device.